#pragma once

// Include framework headers
#include "plugin.h"
#include "resultsink.h"

/**
 * @brief The plugin-specific plugin object
 *
 * The plugin object serves as central object in the nxt plugin.
 */
class MyPlugin : public IDS::NXT::Plugin
{
    // This Qt macro is needed for the signal/slot mechanism
    Q_OBJECT

public:
    /**
     * @brief Constructor
     * @param argc count of command line arguments
     * @param argv list of command line arguments
     */
    MyPlugin(int &argc, char **argv);


private slots:

    /**
     * @brief Slot for new results. This slot is called on every (part) result of the connected source.
     * @param imagekey  The image processed by the connected vision app.
     * @param part  Entry of the images's result list
     * @param result Result that is passed to the plugin
     *
    **/
    void newResult(const QString &imagekey,const QString &part, const QVariant &result);

private:

    IDS::NXT::ResultSink _sink1;
};
