#include "nxthardwaredevicerest.h"
#include "nxthardwaredevicerest_pimpl.h"

namespace Nxt {
namespace Internal {

NxtHardwareDeviceREST::NxtHardwareDeviceREST(QString host, QObject *parent)
    : QObject(parent)
    , m_pimpl(new pimpl(host, this))
{
}

NxtHardwareDeviceREST::NxtHardwareDeviceREST(QString host, QString username, QString password, QObject *parent)
    : QObject(parent)
    , m_pimpl(new pimpl(host, username, password, this))
{
}

NxtHardwareDeviceREST::~NxtHardwareDeviceREST()
{
}

void NxtHardwareDeviceREST::setHost(const QString &host)
{
    m_pimpl->setHost(host);
}

void NxtHardwareDeviceREST::setUsername(const QString &username)
{
    m_pimpl->setUsername(username);
}

void NxtHardwareDeviceREST::setPassword(const QString &password)
{
    m_pimpl->setPassword(password);
}

void NxtHardwareDeviceREST::setTimeout(int timeout_sec)
{
    m_pimpl->setTimeout(timeout_sec);
}

bool NxtHardwareDeviceREST::available()
{
    return m_pimpl->available();
}

int NxtHardwareDeviceREST::authenticate()
{
    return m_pimpl->authenticate();
}

QJsonObject NxtHardwareDeviceREST::deviceInfo()
{
    return m_pimpl->deviceInfo();
}

bool NxtHardwareDeviceREST::startVApp(const QString& name)
{
    return m_pimpl->startVApp(name);
}

bool NxtHardwareDeviceREST::startVAppInGdbServer(const QString& name)
{
    return m_pimpl->startVAppInGdbServer(name);
}

} // namespace Internal
} // namespace Nxt
