/****************************************************************************
**
** Copyright (C) 2012 - 2014 Jolla Ltd.
** Contact: http://jolla.com/
**
** This file is part of Qt Creator.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Digia.
**
****************************************************************************/

#ifndef NXTHARDWAREDEVICEWIDGET_H
#define NXTHARDWAREDEVICEWIDGET_H

#include <projectexplorer/devicesupport/idevicewidget.h>

namespace Nxt {
namespace Internal {

namespace Ui {
class NxtHardwareDeviceWidget;
}

class NxtHardwareDeviceWidget : public ProjectExplorer::IDeviceWidget
{
    Q_OBJECT
public:
    explicit NxtHardwareDeviceWidget(const ProjectExplorer::IDevice::Ptr &deviceConfig, QWidget *parent = 0);
    ~NxtHardwareDeviceWidget() override;

private slots:
    void hostNameEditingFinished();
#if 0 /* ssh */
    void sshPortEditingFinished();
    void timeoutEditingFinished();
#endif /* ssh */
    void userNameEditingFinished();
#if 0 /* ssh */
    void handleFreePortsChanged();
    void authorizePrivateKey();
#endif /* ssh */
    void passwordEditingFinished();

private:
    void updateDeviceFromUi() override;
#if 0 /* ssh */
    void updatePortsWarningLabel();
    void updatePrivateKeyWarningLabel();
#endif /* ssh */
    void initGui();

    Ui::NxtHardwareDeviceWidget *m_ui;
};

} // namespace Internal
} // namespace Nxt

#endif // NXTDEVICECONFIGURATIONWIDGET_H
