/****************************************************************************
**
** Copyright (C) 2012 - 2014 Jolla Ltd.
** Contact: http://jolla.com/
**
** This file is part of Qt Creator.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Digia.
**
****************************************************************************/

#ifndef NXTCONSTANTS_H
#define NXTCONSTANTS_H

#include <qglobal.h> // for Q_OS_*

namespace Nxt {
namespace Constants {

#define NXT_BUILD_ENGINE_NAME_OPTION "IDS NXT Vision App Creator Build Engine"
#define NXT_TOOLCHAIN_NAME_ARM_OPTION "aarch64-eldvas-linux"
#define NXT_TOOLCHAIN_NAME_X64_OPTION "x86_64-eldvassdk-linux"
#define NXT_COMPILER_CPP_ARM_FILENAME_OPTION NXT_TOOLCHAIN_NAME_ARM_OPTION "-g++"
#define NXT_COMPILER_C_ARM_FILENAME_OPTION NXT_TOOLCHAIN_NAME_ARM_OPTION "-gcc"
#define NXT_DEBUGGER_ARM_FILENAME_OPTION NXT_TOOLCHAIN_NAME_ARM_OPTION "-gdb"
#define NXT_DEBUGGER_ARM_VERSION_OPTION "8.2"
#define NXT_TOOLCHAIN_VERSION "1.3.0"
#define NXT_TOOLCHAIN_PATH_OPTION "/opt/eldvas/" NXT_TOOLCHAIN_VERSION
#define NXT_TOOLCHAIN_ENVIRONMENT_SETUP_OPTION "environment-setup-" NXT_TOOLCHAIN_NAME_ARM_OPTION
#define NXT_ARM_IDENTIFIER_OPTION "aarch64"

const char NXT_SETUP_APPVENDOR[] = "IDS";
const char NXT_SETUP_APPNAME[] = "NXT Vision App Creator";
const char NXT_SETUP_APPDATA_VENDOR[] = "IDS";
const char NXT_SETUP_APPDATA_PRODUCT[] = "NXT";
const char NXT_SETUP_APPDATA_APPNAME[] = "IdsNxtVisionAppCreator";
const char NXT_SETUP_NXT_API[] = "2.4.0";
const char NXT_SETUP_NXT_OS[] = "1.4.0";
const char NXT_SETUP_TARGET_NAME[] = "NXT-2.4.0-aarch64";
const char NXT_SETUP_GCC_DUMPMACHINE[] = NXT_TOOLCHAIN_NAME_ARM_OPTION;
const char NXT_SETUP_GCC_DUMPVERSION[] = "8.2.0";
const unsigned int NXT_SETUP_WWW_PORT = 10824;

const char NXT_QTC_PLUGIN_NAME[] = "NXT";
const char NXT_BUILD_ENGINE_NAME[] = NXT_BUILD_ENGINE_NAME_OPTION;

const char NXT_QT[] = "QmakeProjectManager.QtVersion.Nxt";
const char NXT_TOOLCHAIN_ID[] = "QmakeProjectManager.ToolChain.Nxt";

const char NXT_OPTIONS_CATEGORY[] = "W.Nxt";
const char NXT_OPTIONS_CATEGORY_TR[] = QT_TRANSLATE_NOOP("Nxt", "IDS NXT");
const char NXT_OPTIONS_CATEGORY_ICON[] = ":/images/icon-s-nxt-qtcreator.png";
const char NXT_OPTIONS_CATEGORY_ICON_MASK[] = ":/images/icon-s-nxt-qtcreator-mask.png";
const char NXT_OPTIONS_ID[] = "A.Nxt";
const char NXT_OPTIONS_NAME[] = QT_TRANSLATE_NOOP("Nxt", "Build Engine");
const char NXT_GENERAL_OPTIONS_ID[] = "A.NxtGeneral";
const char NXT_GENERAL_OPTIONS_NAME[] = QT_TRANSLATE_NOOP("Nxt", "General");

const char NXT_DEVICE_TYPE[] = "Nxt.Device.Type";
const char NXT_ARM_IDENTIFIER[] = NXT_ARM_IDENTIFIER_OPTION;
const char NXT_MENU[] = "Nxt.Menu";
const char NXT_START_MENU[] = "Nxt.Start.Menu";
const char NXT_STOP_MENU[] = "Nxt.Stop.Menu";
const char NXT_VM_GROUP_MENU[] = "Nxt.Vm.Group.Menu";
const char NXT_OTHER_GROUP_MENU[] = "Nxt.Other.Group.Menu";
const char NXT_START_ICON[] = ":/images/sdk-run.png";
const char NXT_STOP_ICON[] = ":/images/sdk-stop.png";

const char NXT_TOOLS_MENU[] = "Nxt.Tools.Menu";

#ifdef Q_OS_WIN
#define SCRIPT_EXTENSION ".cmd"
#define EXECUTABLE_EXTENSION ".exe"
#else // Q_OS_WIN
#define SCRIPT_EXTENSION ""
#define EXECUTABLE_EXTENSION ""
#endif // Q_OS_WIN

// add these defines in the wrapper script list in nxttarget.cpp
const char NXT_WRAPPER_QMAKE[] = "qmake" SCRIPT_EXTENSION;
const char NXT_WRAPPER_MAKE[] = "make" SCRIPT_EXTENSION;
const char NXT_WRAPPER_GCC[] = "gcc" SCRIPT_EXTENSION;
const char NXT_WRAPPER_GDB[] = "gdb" SCRIPT_EXTENSION;
const char NXT_WRAPPER_NXTDEPLOY[] = "nxtdeploy" SCRIPT_EXTENSION;

const char NXT_DEVICE_DEFAULT_HOST[] = "192.168.x.x";
const char NXT_DEVICE_DEFAULTUSER[] = "admin";
const char NXT_DEVICE_DEFAULTPASS[] = "ids";

const char NXT_VM_LOOPBACK_IP[] = "127.0.0.2";
const unsigned int NXT_VM_SSH_PORT = 10823;
const int  NXT_VM_SSH_PORT_CONNECTIONTIMEOUT_S = 120;
const char NXT_VM_DEFAULTUSER[] = "nxt";


// Keys used for ini files
const char NXT_SDK_TOOLS[] = "/nxt-sdk-tools/";
const char NXT_SDK_DATA_KEY[] = "NxtSDK.";
const char NXT_TARGET_KEY[] = "NxtTarget.Target";
const char NXT_TARGET_DATA_KEY[] = "NxtTarget.";
const char NXT_SDK_COUNT_KEY[] = "NxtSDK.Count";
const char NXT_TARGET_COUNT_KEY[] = "NxtTarget.Count";
const char NXT_SDK_FILE_VERSION_KEY[] = "NxtSDK.Version";
const char NXT_TARGET_FILE_VERSION_KEY[] = "NxtTarget.Version";
const char NXT_SDK_INSTALLDIR[] = "NxtSDK.InstallDir";
const char NXT_DEVICE_MODELS_FILE_VERSION_KEY[] = "NxtDeviceModels.Version";
const char NXT_DEVICE_MODELS_COUNT_KEY[] = "NxtDeviceModels.Count";
const char NXT_DEVICE_MODELS_DATA_KEY[] = "NxtDeviceModels.";
const char NXT_DEVICE_MODEL_NAME[] = "NxtDeviceModel.Name";
const char NXT_DEVICE_MODEL_DISPLAY_RESOLUTION[] = "NxtDeviceModel.DisplayResolution";
const char NXT_DEVICE_MODEL_DISPLAY_SIZE[] = "NxtDeviceModel.DisplaySize";
const char NXT_DEVICE_MODEL_DCONF_DB[] = "NxtDeviceModel.DconfDb";
const char VM_NAME[] = "VirtualMachineName";
const qint64 VM_MINIMAL_FREE_DISCSPACE = 10737418240; // 10GB
const char SHARED_HOME[] = "SharedHome";
const char SHARED_TARGET[] = "SharedTarget";
const char SHARED_CONFIG[] = "SharedConfig";
const char SHARED_SRC[] = "SharedSrc";
const char SHARED_SSH[] = "SharedSsh";
const char AUTHENTICATION_TYPE[] = "AuthenticationType";
const char HOST[] = "Host";
const char USERNAME[] = "Username";
const char PASSWORD[] = "Password";
const char KEY[] = "Key";
const char PRIVATE_KEY_FILE[] = "PrivateKeyFile";
const char SSH_PORT[] = "SshPort";
const char SSH_TIMEOUT[] = "SshTimeout";
const char WWW_PORT[] = "WwwPort";
const char HEADLESS[] = "Headless";
const char ID[] = "Id";
const char NAME[] = "Name";
const char KITS[] = "Kits";
const char SYSROOT[] = "Sysroot";
const char TOOL_CHAINS[] = "ToolChains";
const char QT_VERSIONS[] = "QtVersions";
const char AUTO_DETECTED[] = "AutoDetected";
const char VIRTUAL_MACHINE[] = "VirtualMachine";
const char SB2_TARGET_NAME[] = "SB2.TargetName";

const char NXT_RUNCONFIGURATION_PREFIX[] = "QmakeProjectManager.NxtRunConfiguration:";
const char NXT_RUNRESTCONFIGURATION_PREFIX[] = "QmakeProjectManager.NxtRunRestConfiguration:";

const char NXT_HARDWARE_DEPLOYKEY_ACTION_ID[] = "Nxt.NxtHardwareDeployAction";
const char NXT_SDK_CONNECTON_ACTION_ID[] = "Nxt.SdkConnectionAction";

const char NXT_WIZARD_FEATURE_NXT[] = "Nxt.Wizard.Feature.NXT";

const char NXT_SDK_FILENAME[] = "/qtcreator/nxtsdk.xml";
const char NXT_TARGETS_FILENAME[] = "/targets.xml";
const char NXT_DEVICES_FILENAME[] = "/devices.xml";
const char NXT_DEVICE_MODELS_FILENAME[] = "/qtcreator/nxtsdk-device-models.xml";
const char NXT_COMPILER_CPP_ARM_FILENAME[] = NXT_COMPILER_CPP_ARM_FILENAME_OPTION;
const char NXT_COMPILER_C_ARM_FILENAME[] = NXT_COMPILER_C_ARM_FILENAME_OPTION;
const char NXT_DEBUGGER_ARM_FILENAME[] = NXT_DEBUGGER_ARM_FILENAME_OPTION;
const char NXT_DEBUGGER_ARM_VERSION[] = NXT_DEBUGGER_ARM_VERSION_OPTION;
const char NXT_DEBUGGER_FILENAME_PREFIX[] = "gdb-";

const char NXT_TARGET_NAME[] = "NxtTarget.Name";
const char NXT_TARGET_QMAKE_DUMP[] = "NxtTarget.QmakeQuery";
const char NXT_TARGET_GCC_DUMP[] = "NxtTarget.GccDumpMachine";
const char NXT_TARGET_DEFAULT_DEBUGGER[] = "NxtTarget.DefaultDebugger";

// files in nxt-sdk-tools with cached command result
const char QMAKE_QUERY[] = "qmake.query"; // qmake -query
const char QMAKE_VERSION[] = "qmake.version"; // qmake -version
const char GCC_DUMPMACHINE[] = "gcc.dumpmachine"; // gcc -dumpmachine
const char GCC_DUMPVERSION[] = "gcc.dumpversion"; // gcc -dumpversion

const char NXT_AUTHORIZEDKEYS_FOLDER[] = "authorized_keys";

const char NXT_SSH_PROJECT_PATH[] = "NXT_SSH_PROJECT_PATH";
const char NXT_SSH_SHARED_HOME[] = "NXT_SSH_SHARED_HOME";
const char NXT_SSH_SHARED_TARGET[] = "NXT_SSH_SHARED_TARGET";
const char NXT_SSH_SHARED_SRC[] = "NXT_SSH_SHARED_SRC";
const char NXT_SSH_SDK_TOOLS[] = "NXT_SSH_SDK_TOOLS";
const char NXT_SSH_USERNAME[] = "NXT_SSH_USERNAME";
const char NXT_SSH_PRIVATE_KEY[] = "NXT_SSH_PRIVATE_KEY";
const char NXT_SSH_TARGET_NAME[] = "NXT_SSH_TARGET_NAME";
const char NXT_SSH_DEVICE_NAME[] = "NXT_SSH_DEVICE_NAME";
const char NXT_SSH_PORT[] = "NXT_SSH_PORT";
const char NXT_SDK_ENVIRONMENT_FILTER[] = "NXT_SDK_ENVIRONMENT_FILTER";
const char NXT_DEVICE_VIRTUAL_MACHINE[] = "NXT_DEVICE_VIRTUAL_MACHINE";
const char NXT_DEVICE_MAC[] = "NXT_DEVICE_MAC";
const char NXT_DEVICE_SUBNET[] = "NXT_DEVICE_SUBNET";
const char NXT_DEVICE_SHARED_SSH[] = "NXT_DEVICE_SHARED_SSH";
const char NXT_DEVICE_SHARED_CONFIG[] = "NXT_DEVICE_SHARED_CONFIG";
const char NXT_DEVICE_ARCHITECTURE[] = "NXT_DEVICE_ARCHITECTURE";
const char NXT_DEVICE_DEVICE_MODEL[] = "NXT_DEVICE_DEVICE_MODEL";
const char NXT_DEVICE_ORIENTATION[] = "NXT_DEVICE_ORIENTATION";
const char NXT_DEVICE_VIEW_SCALED[] = "NXT_DEVICE_VIEW_SCALED";

const char NXT_FRAMEWORK[] = "NXT_FRAMEWORK";
const char NXT_FRAMEWORK_PATH[] = "/home/nxt/nxt_framework";

const char NXT_TOOLCHAIN_PATH[] = NXT_TOOLCHAIN_PATH_OPTION;
const char NXT_TOOLCHAIN_NAME_ARM[] = NXT_TOOLCHAIN_NAME_ARM_OPTION;
const char NXT_TOOLCHAIN_ENVIRONMENT_SETUP[] = NXT_TOOLCHAIN_ENVIRONMENT_SETUP_OPTION;
const char NXT_TOOLCHAIN_NAME_HOST[] = NXT_TOOLCHAIN_NAME_X64_OPTION;

const char NXT_TOOLCHAIN_SYSROOT_TARGET[] = NXT_TOOLCHAIN_PATH_OPTION "/sysroots/" NXT_TOOLCHAIN_NAME_ARM_OPTION;
const char NXT_TOOLCHAIN_DEBUG_INFO_LOCATION[] = NXT_TOOLCHAIN_PATH_OPTION "/sysroots/" NXT_TOOLCHAIN_NAME_ARM_OPTION "/usr/src/debug";

const char NXT_TOOLCHAIN_GCC_MACROS[] =
R"(#define __DBL_MIN_EXP__ (-1021)
#define __FLT32X_MAX_EXP__ 1024
#define __cpp_attributes 200809
#define __UINT_LEAST16_MAX__ 0xffff
#define __ARM_SIZEOF_WCHAR_T 4
#define __ATOMIC_ACQUIRE 2
#define __FLT128_MAX_10_EXP__ 4932
#define __FLT_MIN__ 1.17549435082228750796873653722224568e-38F
#define __GCC_IEC_559_COMPLEX 2
#define __cpp_aggregate_nsdmi 201304
#define __UINT_LEAST8_TYPE__ unsigned char
#define __INTMAX_C(c) c ## L
#define __CHAR_BIT__ 8
#define __UINT8_MAX__ 0xff
#define __WINT_MAX__ 0xffffffffU
#define __FLT32_MIN_EXP__ (-125)
#define __cpp_static_assert 200410
#define __ORDER_LITTLE_ENDIAN__ 1234
#define __SIZE_MAX__ 0xffffffffffffffffUL
#define __WCHAR_MAX__ 0xffffffffU
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_1 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_2 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_4 1
#define __DBL_DENORM_MIN__ double(4.94065645841246544176568792868221372e-324L)
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_8 1
#define __GCC_ATOMIC_CHAR_LOCK_FREE 2
#define __GCC_IEC_559 2
#define __FLT32X_DECIMAL_DIG__ 17
#define __FLT_EVAL_METHOD__ 0
#define __unix__ 1
#define __cpp_binary_literals 201304
#define __FLT64_DECIMAL_DIG__ 17
#define __GCC_ATOMIC_CHAR32_T_LOCK_FREE 2
#define __cpp_variadic_templates 200704
#define __UINT_FAST64_MAX__ 0xffffffffffffffffUL
#define __SIG_ATOMIC_TYPE__ int
#define __DBL_MIN_10_EXP__ (-307)
#define __FLT16_EPSILON__ 9.76562500000000000000000000000000000e-4F16
#define __FINITE_MATH_ONLY__ 0
#define __cpp_variable_templates 201304
#define __ARM_FEATURE_UNALIGNED 1
#define __GNUC_PATCHLEVEL__ 0
#define __FLT32_HAS_DENORM__ 1
#define __UINT_FAST8_MAX__ 0xff
#define __has_include(STR) __has_include__(STR)
#define __DEC64_MAX_EXP__ 385
#define __INT8_C(c) c
#define __INT_LEAST8_WIDTH__ 8
#define __UINT_LEAST64_MAX__ 0xffffffffffffffffUL
#define __SHRT_MAX__ 0x7fff
#define __LDBL_MAX__ 1.18973149535723176508575932662800702e+4932L
#define __ARM_FEATURE_IDIV 1
#define __FLT64X_MAX_10_EXP__ 4932
#define __ARM_FP 14
#define __UINT_LEAST8_MAX__ 0xff
#define __GCC_ATOMIC_BOOL_LOCK_FREE 2
#define __FLT128_DENORM_MIN__ 6.47517511943802511092443895822764655e-4966F128
#define __UINTMAX_TYPE__ long unsigned int
#define __linux 1
#define __DEC32_EPSILON__ 1E-6DF
#define __FLT_EVAL_METHOD_TS_18661_3__ 0
#define __CHAR_UNSIGNED__ 1
#define __UINT32_MAX__ 0xffffffffU
#define __GXX_EXPERIMENTAL_CXX0X__ 1
#define __AARCH64_CMODEL_SMALL__ 1
#define __LDBL_MAX_EXP__ 16384
#define __FLT128_MIN_EXP__ (-16381)
#define __WINT_MIN__ 0U
#define __linux__ 1
#define __FLT128_MIN_10_EXP__ (-4931)
#define __INT_LEAST16_WIDTH__ 16
#define __SCHAR_MAX__ 0x7f
#define __FLT128_MANT_DIG__ 113
#define __WCHAR_MIN__ 0U
#define __INT64_C(c) c ## L
#define __DBL_DIG__ 15
#define __GCC_ATOMIC_POINTER_LOCK_FREE 2
#define __FLT64X_MANT_DIG__ 113
#define __SIZEOF_INT__ 4
#define __SIZEOF_POINTER__ 8
#define __GCC_ATOMIC_CHAR16_T_LOCK_FREE 2
#define __USER_LABEL_PREFIX__
#define __FLT64X_EPSILON__ 1.92592994438723585305597794258492732e-34F64x
#define __STDC_HOSTED__ 1
#define __LDBL_HAS_INFINITY__ 1
#define __ARM_ALIGN_MAX_STACK_PWR 16
#define __FLT32_DIG__ 6
#define __FLT_EPSILON__ 1.19209289550781250000000000000000000e-7F
#define __GXX_WEAK__ 1
#define __SHRT_WIDTH__ 16
#define __LDBL_MIN__ 3.36210314311209350626267781732175260e-4932L
#define __DEC32_MAX__ 9.999999E96DF
#define __cpp_threadsafe_static_init 200806
#define __ARM_SIZEOF_MINIMAL_ENUM 4
#define __FLT64X_DENORM_MIN__ 6.47517511943802511092443895822764655e-4966F64x
#define __FLT32X_HAS_INFINITY__ 1
#define __INT32_MAX__ 0x7fffffff
#define __INT_WIDTH__ 32
#define __SIZEOF_LONG__ 8
#define __UINT16_C(c) c
#define __PTRDIFF_WIDTH__ 64
#define __DECIMAL_DIG__ 36
#define __FLT64_EPSILON__ 2.22044604925031308084726333618164062e-16F64
#define __gnu_linux__ 1
#define __INTMAX_WIDTH__ 64
#define __FLT64_MIN_EXP__ (-1021)
#define __has_include_next(STR) __has_include_next__(STR)
#define __FLT64X_MIN_10_EXP__ (-4931)
#define __LDBL_HAS_QUIET_NAN__ 1
#define __FLT16_MIN_EXP__ (-13)
#define __FLT64_MANT_DIG__ 53
#define __GNUC__ 8
#define __GXX_RTTI 1
#define __cpp_delegating_constructors 200604
#define __FLT_HAS_DENORM__ 1
#define __SIZEOF_LONG_DOUBLE__ 16
#define __BIGGEST_ALIGNMENT__ 16
#define __STDC_UTF_16__ 1
#define __FLT64_MAX_10_EXP__ 308
#define __FLT16_MAX_10_EXP__ 4
#define __FLT32_HAS_INFINITY__ 1
#define __DBL_MAX__ double(1.79769313486231570814527423731704357e+308L)
#define __cpp_raw_strings 200710
#define __INT_FAST32_MAX__ 0x7fffffffffffffffL
#define __DBL_HAS_INFINITY__ 1
#define __DEC32_MIN_EXP__ (-94)
#define __INTPTR_WIDTH__ 64
#define __FLT32X_HAS_DENORM__ 1
#define __INT_FAST16_TYPE__ long int
#define __LDBL_HAS_DENORM__ 1
#define __cplusplus 201402L
#define __cpp_ref_qualifiers 200710
#define __DEC128_MAX__ 9.999999999999999999999999999999999E6144DL
#define __INT_LEAST32_MAX__ 0x7fffffff
#define __DEC32_MIN__ 1E-95DF
#define __DEPRECATED 1
#define __cpp_rvalue_references 200610
#define __DBL_MAX_EXP__ 1024
#define __WCHAR_WIDTH__ 32
#define __FLT32_MAX__ 3.40282346638528859811704183484516925e+38F32
#define __DEC128_EPSILON__ 1E-33DL
#define __FLT16_DECIMAL_DIG__ 5
#define __PTRDIFF_MAX__ 0x7fffffffffffffffL
#define __FLT32_HAS_QUIET_NAN__ 1
#define __GNUG__ 8
#define __LONG_LONG_MAX__ 0x7fffffffffffffffLL
#define __SIZEOF_SIZE_T__ 8
#define __cpp_rvalue_reference 200610
#define __ARM_ALIGN_MAX_PWR 28
#define __cpp_nsdmi 200809
#define __FLT64X_MIN_EXP__ (-16381)
#define __SIZEOF_WINT_T__ 4
#define __LONG_LONG_WIDTH__ 64
#define __cpp_initializer_lists 200806
#define __FLT32_MAX_EXP__ 128
#define __cpp_hex_float 201603
#define __GCC_HAVE_DWARF2_CFI_ASM 1
#define __ARM_FP16_FORMAT_IEEE 1
#define __GXX_ABI_VERSION 1013
#define __FLT128_HAS_INFINITY__ 1
#define __FLT_MIN_EXP__ (-125)
#define __FLT16_MANT_DIG__ 11
#define __cpp_lambdas 200907
#define __FLT64X_HAS_QUIET_NAN__ 1
#define __INT_FAST64_TYPE__ long int
#define __FP_FAST_FMAF 1
#define __FLT64_DENORM_MIN__ 4.94065645841246544176568792868221372e-324F64
#define __DBL_MIN__ double(2.22507385850720138309023271733240406e-308L)
#define __FLT16_DENORM_MIN__ 5.96046447753906250000000000000000000e-8F16
#define __LP64__ 1
#define __FLT_EVAL_METHOD_C99__ 0
#define __FLT32X_EPSILON__ 2.22044604925031308084726333618164062e-16F32x
#define __aarch64__ 1
#define __FLT64_MIN_10_EXP__ (-307)
#define __ARM_FP16_ARGS 1
#define __FLT16_MIN_10_EXP__ (-4)
#define __FLT64X_DECIMAL_DIG__ 36
#define __DEC128_MIN__ 1E-6143DL
#define __REGISTER_PREFIX__
#define __UINT16_MAX__ 0xffff
#define __DBL_HAS_DENORM__ 1
#define __FLT32_MIN__ 1.17549435082228750796873653722224568e-38F32
#define __UINT8_TYPE__ unsigned char
#define __NO_INLINE__ 1
#define __FLT_MANT_DIG__ 24
#define __LDBL_DECIMAL_DIG__ 36
#define __VERSION__ "8.2.0"
#define __UINT64_C(c) c ## UL
#define __cpp_unicode_characters 200704
#define __cpp_decltype_auto 201304
#define __ARM_FEATURE_FMA 1
#define __GCC_ATOMIC_INT_LOCK_FREE 2
#define __FLT128_MAX_EXP__ 16384
#define __FLT32_MANT_DIG__ 24
#define __FLOAT_WORD_ORDER__ __ORDER_LITTLE_ENDIAN__
#define __FLT32X_MIN_EXP__ (-1021)
#define __FLT16_DIG__ 3
#define __FLT128_HAS_DENORM__ 1
#define __FLT128_DIG__ 33
#define __SCHAR_WIDTH__ 8
#define __INT32_C(c) c
#define __DEC64_EPSILON__ 1E-15DD
#define __ORDER_PDP_ENDIAN__ 3412
#define __DEC128_MIN_EXP__ (-6142)
#define __FLT32_MAX_10_EXP__ 38
#define __ARM_64BIT_STATE 1
#define __INT_FAST32_TYPE__ long int
#define __UINT_LEAST16_TYPE__ short unsigned int
#define __FLT64X_HAS_INFINITY__ 1
#define unix 1
#define __INT16_MAX__ 0x7fff
#define __cpp_rtti 199711
#define __SIZE_TYPE__ long unsigned int
#define __UINT64_MAX__ 0xffffffffffffffffUL
#define __FLT64X_DIG__ 33
#define __INT8_TYPE__ signed char
#define __cpp_digit_separators 201309
#define __ELF__ 1
#define __FLT_RADIX__ 2
#define __INT_LEAST16_TYPE__ short int
#define __ARM_ARCH_PROFILE 65
#define __LDBL_EPSILON__ 1.92592994438723585305597794258492732e-34L
#define __UINTMAX_C(c) c ## UL
#define __GLIBCXX_BITSIZE_INT_N_0 128
#define __ARM_PCS_AAPCS64 1
#define __SIG_ATOMIC_MAX__ 0x7fffffff
#define __GCC_ATOMIC_WCHAR_T_LOCK_FREE 2
#define __SIZEOF_PTRDIFF_T__ 8
#define __FLT32X_MANT_DIG__ 53
#define __AARCH64EL__ 1
#define __FLT16_MAX_EXP__ 16
#define __DEC32_SUBNORMAL_MIN__ 0.000001E-95DF
#define __INT_FAST16_MAX__ 0x7fffffffffffffffL
#define __FLT64_DIG__ 15
#define __UINT_FAST32_MAX__ 0xffffffffffffffffUL
#define __UINT_LEAST64_TYPE__ long unsigned int
#define __FLT_HAS_QUIET_NAN__ 1
#define __FLT_MAX_10_EXP__ 38
#define __LONG_MAX__ 0x7fffffffffffffffL
#define __FLT64X_HAS_DENORM__ 1
#define __DEC128_SUBNORMAL_MIN__ 0.000000000000000000000000000000001E-6143DL
#define __FLT_HAS_INFINITY__ 1
#define __unix 1
#define __cpp_unicode_literals 200710
#define __UINT_FAST16_TYPE__ long unsigned int
#define __DEC64_MAX__ 9.999999999999999E384DD
#define __INT_FAST32_WIDTH__ 64
#define __CHAR16_TYPE__ short unsigned int
#define __PRAGMA_REDEFINE_EXTNAME 1
#define __SIZE_WIDTH__ 64
#define __INT_LEAST16_MAX__ 0x7fff
#define __DEC64_MANT_DIG__ 16
#define __INT64_MAX__ 0x7fffffffffffffffL
#define __UINT_LEAST32_MAX__ 0xffffffffU
#define __FLT32_DENORM_MIN__ 1.40129846432481707092372958328991613e-45F32
#define __GCC_ATOMIC_LONG_LOCK_FREE 2
#define __SIG_ATOMIC_WIDTH__ 32
#define __INT_LEAST64_TYPE__ long int
#define __ARM_FEATURE_CLZ 1
#define __INT16_TYPE__ short int
#define __INT_LEAST8_TYPE__ signed char
#define __FLT16_MAX__ 6.55040000000000000000000000000000000e+4F16
#define __DEC32_MAX_EXP__ 97
#define __INT_FAST8_MAX__ 0x7f
#define __ARM_ARCH 8
#define __FLT128_MAX__ 1.18973149535723176508575932662800702e+4932F128
#define __INTPTR_MAX__ 0x7fffffffffffffffL
#define __cpp_sized_deallocation 201309
#define linux 1
#define __cpp_range_based_for 200907
#define __FLT64_HAS_QUIET_NAN__ 1
#define __FLT32_MIN_10_EXP__ (-37)
#define __EXCEPTIONS 1
#define __LDBL_MANT_DIG__ 113
#define __DBL_HAS_QUIET_NAN__ 1
#define __FLT64_HAS_INFINITY__ 1
#define __FLT64X_MAX__ 1.18973149535723176508575932662800702e+4932F64x
#define __FLT16_HAS_INFINITY__ 1
#define __SIG_ATOMIC_MIN__ (-__SIG_ATOMIC_MAX__ - 1)
#define __cpp_return_type_deduction 201304
#define __INTPTR_TYPE__ long int
#define __UINT16_TYPE__ short unsigned int
#define __WCHAR_TYPE__ unsigned int
#define __SIZEOF_FLOAT__ 4
#define __UINTPTR_MAX__ 0xffffffffffffffffUL
#define __ARM_ARCH_8A 1
#define __INT_FAST64_WIDTH__ 64
#define __DEC64_MIN_EXP__ (-382)
#define __cpp_decltype 200707
#define __FLT32_DECIMAL_DIG__ 9
#define __INT_FAST64_MAX__ 0x7fffffffffffffffL
#define __GCC_ATOMIC_TEST_AND_SET_TRUEVAL 1
#define __FLT_DIG__ 6
#define __FLT64X_MAX_EXP__ 16384
#define __UINT_FAST64_TYPE__ long unsigned int
#define __INT_MAX__ 0x7fffffff
#define __FLT16_HAS_QUIET_NAN__ 1
#define __INT64_TYPE__ long int
#define __FLT_MAX_EXP__ 128
#define __ORDER_BIG_ENDIAN__ 4321
#define __DBL_MANT_DIG__ 53
#define __cpp_inheriting_constructors 201511
#define __INT_LEAST64_MAX__ 0x7fffffffffffffffL
#define __FP_FAST_FMAF32 1
#define __DEC64_MIN__ 1E-383DD
#define __WINT_TYPE__ unsigned int
#define __UINT_LEAST32_TYPE__ unsigned int
#define __SIZEOF_SHORT__ 2
#define __LDBL_MIN_EXP__ (-16381)
#define __FLT64_MAX__ 1.79769313486231570814527423731704357e+308F64
#define __WINT_WIDTH__ 32
#define __FP_FAST_FMAF64 1
#define __INT_LEAST8_MAX__ 0x7f
#define __FLT32X_MAX_10_EXP__ 308
#define __SIZEOF_INT128__ 16
#define __FLT16_MIN__ 6.10351562500000000000000000000000000e-5F16
#define __WCHAR_UNSIGNED__ 1
#define __LDBL_MAX_10_EXP__ 4932
#define __ATOMIC_RELAXED 0
#define __DBL_EPSILON__ double(2.22044604925031308084726333618164062e-16L)
#define __FLT128_MIN__ 3.36210314311209350626267781732175260e-4932F128
#define _LP64 1
#define __UINT8_C(c) c
#define __FLT64_MAX_EXP__ 1024
#define __INT_LEAST32_TYPE__ int
#define __SIZEOF_WCHAR_T__ 4
#define __ARM_NEON 1
#define __FLT128_HAS_QUIET_NAN__ 1
#define __INT_FAST8_TYPE__ signed char
#define __FLT64X_MIN__ 3.36210314311209350626267781732175260e-4932F64x
#define __GNUC_STDC_INLINE__ 1
#define __FLT64_HAS_DENORM__ 1
#define __FLT32_EPSILON__ 1.19209289550781250000000000000000000e-7F32
#define __FP_FAST_FMAF32x 1
#define __FLT16_HAS_DENORM__ 1
#define __DBL_DECIMAL_DIG__ 17
#define __STDC_UTF_32__ 1
#define __INT_FAST8_WIDTH__ 8
#define __DEC_EVAL_METHOD__ 2
#define __FLT32X_MAX__ 1.79769313486231570814527423731704357e+308F32x
#define __cpp_runtime_arrays 198712
#define __UINT64_TYPE__ long unsigned int
#define __UINT32_C(c) c ## U
#define __INTMAX_MAX__ 0x7fffffffffffffffL
#define __cpp_alias_templates 200704
#define __BYTE_ORDER__ __ORDER_LITTLE_ENDIAN__
#define __FLT_DENORM_MIN__ 1.40129846432481707092372958328991613e-45F
#define __INT8_MAX__ 0x7f
#define __LONG_WIDTH__ 64
#define __UINT_FAST32_TYPE__ long unsigned int
#define __CHAR32_TYPE__ unsigned int
#define __FLT_MAX__ 3.40282346638528859811704183484516925e+38F
#define __FP_FAST_FMA 1
#define __cpp_constexpr 201304
#define __ARM_FEATURE_NUMERIC_MAXMIN 1
#define __INT32_TYPE__ int
#define __SIZEOF_DOUBLE__ 8
#define __cpp_exceptions 199711
#define __FLT_MIN_10_EXP__ (-37)
#define __FLT64_MIN__ 2.22507385850720138309023271733240406e-308F64
#define __INT_LEAST32_WIDTH__ 32
#define __INTMAX_TYPE__ long int
#define __DEC128_MAX_EXP__ 6145
#define __FLT32X_HAS_QUIET_NAN__ 1
#define __ATOMIC_CONSUME 1
#define __GNUC_MINOR__ 2
#define __GLIBCXX_TYPE_INT_N_0 __int128
#define __INT_FAST16_WIDTH__ 64
#define __UINTMAX_MAX__ 0xffffffffffffffffUL
#define __DEC32_MANT_DIG__ 7
#define __FLT32X_DENORM_MIN__ 4.94065645841246544176568792868221372e-324F32x
#define __DBL_MAX_10_EXP__ 308
#define __LDBL_DENORM_MIN__ 6.47517511943802511092443895822764655e-4966L
#define __INT16_C(c) c
#define __ARM_ARCH_ISA_A64 1
#define __cpp_generic_lambdas 201304
#define __STDC__ 1
#define __FLT32X_DIG__ 15
#define __PTRDIFF_TYPE__ long int
#define __ATOMIC_SEQ_CST 5
#define __UINT32_TYPE__ unsigned int
#define __FLT32X_MIN_10_EXP__ (-307)
#define __UINTPTR_TYPE__ long unsigned int
#define __DEC64_SUBNORMAL_MIN__ 0.000000000000001E-383DD
#define __DEC128_MANT_DIG__ 34
#define __LDBL_MIN_10_EXP__ (-4931)
#define __FLT128_EPSILON__ 1.92592994438723585305597794258492732e-34F128
#define __SIZEOF_LONG_LONG__ 8
#define __cpp_user_defined_literals 200809
#define __FLT128_DECIMAL_DIG__ 36
#define __GCC_ATOMIC_LLONG_LOCK_FREE 2
#define __FLT32X_MIN__ 2.22507385850720138309023271733240406e-308F32x
#define __LDBL_DIG__ 33
#define __FLT_DECIMAL_DIG__ 9
#define __UINT_FAST16_MAX__ 0xffffffffffffffffUL
#define __GCC_ATOMIC_SHORT_LOCK_FREE 2
#define __INT_LEAST64_WIDTH__ 64
#define __UINT_FAST8_TYPE__ unsigned char
#define _GNU_SOURCE 1
#define __cpp_init_captures 201304
#define __ATOMIC_ACQ_REL 4
#define __ATOMIC_RELEASE 3
#define _REENTRANT 1
#define __pic__ 2
)";

} // namespace Constants
} // namespace Nxt

#endif // NXTCONSTANTS_H
