/****************************************************************************
**
** Copyright (C) 2012 - 2014 Jolla Ltd.
** Contact: http://jolla.com/
**
** This file is part of Qt Creator.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Digia.
**
****************************************************************************/

#ifndef NXTRUNCONFIGURATION_H
#define NXTRUNCONFIGURATION_H

#include <remotelinux/remotelinuxrunconfiguration.h>

namespace Nxt {
namespace Internal {

class NxtRunConfiguration : public RemoteLinux::RemoteLinuxRunConfiguration
{
    Q_OBJECT
public:
    NxtRunConfiguration(ProjectExplorer::Target *parent);

    ProjectExplorer::Runnable runnable() const override;
    QString defaultRemoteExecutableFilePath() const;
    QString disabledReason() const override;
protected:
    void updateEnabledState() override;
    bool fromMap(const QVariantMap &map) override;
private:
    QString defaultDisplayName() const;
    mutable QString m_disabledReason;
};

} // namespace Internal
} // namespace Nxt

#endif // NXTRUNCONFIGURATION_H
