#include "gdbcommand.h"

#include "../nxtremoteprocess.h"

#include <QDir>
#include <iostream>

GdbCommand::GdbCommand()
{

}

QString GdbCommand::name() const
{
    return QLatin1String("gdb");
}

int GdbCommand::execute()
{
    // remove each argument which equals to "gdb" because we need need to call a special gdb
    auto args = arguments();
    #ifdef IDS_NXT_DEBUG
    qDebug() << "before:" << args;
    #endif /* IDS_NXT_DEBUG */
    for (int i = args.size() - 1; i >= 0; --i)
    {
        if (args[i] == "gdb") {
            args.removeAt(i);
        }
    }

    #ifdef IDS_NXT_DEBUG
    qDebug() << "after:" << args;
    #endif /* IDS_NXT_DEBUG */

    QStringList commands;
    commands << "source " + environment_setup();
    commands << "export " + nxt_framework();
    commands << "aarch64-eldvas-linux-gdb " + args.join(" ");
    QString command = commands.join(" && ");

    NxtRemoteProcess process;
    process.setSshParameters(sshParameters());
    process.setCommand(remotePathMapping(command));
    process.setIntercative(true);
    process.setCacheOutput(false);
    return process.executeAndWait();
}

bool GdbCommand::isValid() const
{
    return Command::isValid() && !targetName().isEmpty() ;
}
