DEFINES += IDS_NXT_PATCH

shared {
    DEFINES += QUAZIP_LIBRARY
} else {
    DEFINES += QTCREATOR_QUAZIP_STATIC_LIB
}

!win32:{
    isEmpty(IDE_LIBEXEC_PATH) | isEmpty(IDE_BIN_PATH): {
        warning("using quazip-lib.pri without IDE_LIBEXEC_PATH or IDE_BIN_PATH results in empty QTC_REL_TOOLS_PATH")
        DEFINES += QTC_REL_TOOLS_PATH=$$shell_quote(\"\")
    } else {
        DEFINES += QTC_REL_TOOLS_PATH=$$shell_quote(\"$$relative_path($$IDE_LIBEXEC_PATH, $$IDE_BIN_PATH)\")
    }
}

CONFIG += qt warn_on
QT -= gui

#!win32:VERSION = 1.0.0

DEFINES += QUAZIP_BUILD
#DEFINES += QT_NO_CAST_FROM_ASCII
DEFINES += QT_NO_CAST_TO_ASCII

CONFIG(staticlib): DEFINES += QUAZIP_STATIC

INCLUDEPATH += $$PWD/quazip
DEPENDPATH += $$PWD

HEADERS += \
    $$PWD/quazip/minizip_crypt.h \
    $$PWD/quazip/ioapi.h \
    $$PWD/quazip/JlCompress.h \
    $$PWD/quazip/quaadler32.h \
    $$PWD/quazip/quachecksum32.h \
    $$PWD/quazip/quacrc32.h \
    $$PWD/quazip/quagzipfile.h \
    $$PWD/quazip/quaziodevice.h \
    $$PWD/quazip/quazipdir.h \
    $$PWD/quazip/quazipfile.h \
    $$PWD/quazip/quazipfileinfo.h \
    $$PWD/quazip/quazip_global.h \
    $$PWD/quazip/quazip.h \
    $$PWD/quazip/quazipnewinfo.h \
    $$PWD/quazip/unzip.h \
    $$PWD/quazip/zip.h

SOURCES += \
    $$PWD/quazip/qioapi.cpp \
    $$PWD/quazip/JlCompress.cpp \
    $$PWD/quazip/quaadler32.cpp \
    $$PWD/quazip/quacrc32.cpp \
    $$PWD/quazip/quagzipfile.cpp \
    $$PWD/quazip/quaziodevice.cpp \
    $$PWD/quazip/quazip.cpp \
    $$PWD/quazip/quazipdir.cpp \
    $$PWD/quazip/quazipfile.cpp \
    $$PWD/quazip/quazipfileinfo.cpp \
    $$PWD/quazip/quazipnewinfo.cpp \
    $$PWD/quazip/unzip.c \
    $$PWD/quazip/zip.c

win32 {
    DEFINES += NOMINMAX
}

INCLUDEPATH += $$PWD/zlib

HEADERS += \
    $$PWD/zlib/crc32.h \
    $$PWD/zlib/deflate.h \
    $$PWD/zlib/gzguts.h \
    $$PWD/zlib/inffast.h \
    $$PWD/zlib/inffixed.h \
    $$PWD/zlib/inflate.h \
    $$PWD/zlib/inftrees.h \
    $$PWD/zlib/trees.h \
    $$PWD/zlib/zutil.h \

HEADERS += \
    $$PWD/zlib/zconf.h \
    $$PWD/zlib/zlib.h \

SOURCES += \
    $$PWD/zlib/adler32.c \
    $$PWD/zlib/compress.c \
    $$PWD/zlib/crc32.c \
    $$PWD/zlib/deflate.c \
    $$PWD/zlib/gzclose.c \
    $$PWD/zlib/gzlib.c \
    $$PWD/zlib/gzread.c \
    $$PWD/zlib/gzwrite.c \
    $$PWD/zlib/inflate.c \
    $$PWD/zlib/infback.c \
    $$PWD/zlib/inftrees.c \
    $$PWD/zlib/inffast.c \
    $$PWD/zlib/trees.c \
    $$PWD/zlib/uncompr.c \
    $$PWD/zlib/zutil.c \

